# $Id: 01_queries.t,v 1.3 2006/09/13 09:44:51 pythontech Exp pythontech $
use strict;
use Test::More tests => 14;

# FIXME
BEGIN {
    # Need Triples & QMap modules but want local Model & QMap
    # Put site libs at end of search path
    push @INC, '/home/pythontech/lib';
}
use PythonTech::Triples::Memory;
use PythonTech::QMap;
use PythonTech::Model;

# Create test data
my $tr = PythonTech::Triples::Memory->new;
my @data = qw(
	    x:foo rdf:type xs:Thing
	    x:foo xs:name =Fooey
	    x:bar rdf:type xs:Stuff
	    x:bar xs:owner x:foo
);
while (my($s,$p,$o) = splice(@data,0,3)) {
    $tr->add($s,$p,$o);
}

# Tests with no URI manipulation
my $model = PythonTech::Model->new(triples => $tr,
				   classmap => {},
				   dbqmap => undef,
				   extqmap => undef);

my $foo = $model->as_obj('x:foo');
is(ref($foo), 'PythonTech::Obj', 'found obj');
my $bar = $foo && $foo->rattr('xs:owner');
is(ref($bar), 'PythonTech::Obj', 'reverse attr');

# array query
my @things = $model->query(undef, 'rdf:type', \ 'xs:Thing');
is(scalar @things, 1, 'query count');
is($things[0]->[0], $foo, 'query result');
my @typed = $model->query(undef, 'rdf:type', undef);
is(scalar @typed, 2, 'query count[2]');
@typed = sort {$a->[0]->uri cmp $b->[0]->uri} @typed;
is($typed[0]->[0], $bar, 'query subject[0]');
is($typed[0]->[1]->uri, 'xs:Stuff', 'query object[0]');
is($typed[1]->[0], $foo, 'query subject[1]');
is($typed[1]->[1]->uri, 'xs:Thing', 'query object[1]');
# scalar query
my $thing = $model->query(undef, 'rdf:type', \ 'xs:Thing');
is(defined $thing, 1, 'query success');
is($thing->[0], $foo, 'query result');
is($thing->[0]->uri, $foo->uri, 'query result');

# array sp2o
my @name = $model->sp2o($foo, 'xs:name');
is(scalar @name, 1, 'sp2o count');
is($name[0], 'Fooey');

#End
